/*********************************************************************
 *                
 * Filename:      crc.h
 * Version:       
 * Description:   CRC routines
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Mon Aug  4 20:40:53 1997
 * Modified at:   Sat Oct 25 08:43:59 1997
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 ********************************************************************/

#ifndef CRC_H
#define CRC_H

#include <linux/types.h>

#define INIT_FCS  0xffff   /* Initial FCS value */
#define GOOD_FCS  0xf0b8   /* Good final FCS value */

#define IR_FCS(fcs, byte)((fcs >> 8)^irda_crc16_table[ (fcs^byte) & 0xff])

unsigned short crc_calc( __u16 oldfcs, __u8 *buf, int len);

extern __u16 irda_crc16_table[];

#endif
