/*********************************************************************
 *                
 * Filename:      fir_port.c
 * Version:       0.1
 * Description:   Fast IrDa Port implementation
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Sun Oct 26 07:18:56 1997
 * Modified at:   Tue Dec  2 12:05:21 1997
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1997 Dag Brattli <dagb@cs.uit.no>, All Rights Reserved.
 *     
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *
 *     Neither Dag Brattli nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *
 ********************************************************************/

/* FIR Control Register */
/* Bank 0 */
#define FIR_CREG0_MCR    0x0  /* Master Control Register (R/W) */
#define FIR_CREG0_MSR    0x1  /* Master Status Register (R) */
#define FIR_CREG0_MiSR   0x1  /* Miscellaneous Control Register (W) */
#define FIR_CREG0_RxFIFO 0x2  /* (R) */
#define FIR_CREG0_RxFIFO 0x2  /* (W) */
#define FIR_CREG0_TxCTL1 0x3  /* Tx Control Register 1 (R/W) */
#define FIR_CREG0_TxCTL2 0x4  /* Tx Control Register 2 (R/W) */
#define FIR_CREG0_TxSTAT 0x5  /* Tx Status Register (R) */
#define FIR_CREG0_RxCTL  0x6  /* Rx Control Register (R/W) */
#define FIR_CREG0_RxSTAT 0x7  /* Rx Status Register (R) */
#define FIR_CREG0_RCR    0x8  /* Reset Command Register (R/W) */

/* Bank 1 */
#define FIR_CREG1_MCR     0x0  /* Master Control Register (R/W) */
#define FIR_CREG1_FAR     0x1  /* Frame Address Register (R/W) */
#define FIR_CREG1_RxBCLR  0x2  /* Rx Byte Count Low Register (R) */
#define FIR_CREG1_RxBCHR  0x3  /* Rx Byte Count High Register (R) */
#define FIR_CREG1_RxRFPLR 0x4  /* Rx Ring Frame Pointer Low Register (R) */
#define FIR_CREG1_RxRFPHR 0x5  /* Rx Ring Frame Pointer High Register (R) */
#define FIR_CREG1_TxBCLR  0x6  /* Tx Byte Count Low Register (R/W) */
#define FIR_CREG1_TxBCHR  0x7  /* Tx Byte Count High Register (R/W) */

/* Bank 2 */
#define FIR_CREG2_MCR   0x0  /* Master Control Register (R/W) */
#define FIR_CREG2_IC1R  0x1  /* Infrared Configuration 1 Register (R/W) */
#define FIR_CREG2_ITCR1 0x2  /* Infrared Transceiver Control Regiser 1 (R/W) */
#define FIR_CREG2_ITCR2 0x3  /* Infrared Transceiver Control Regiser 2 (R/W) */
#define FIR_CREG2_TR    0x4  /* Timer Register (R/W) */
#define FIR_CREG2_IC3R  0x5  /* Infrared Configuration 3 Register (R/W) */
#define FIR_CREG2_MTR   0x6  /* Modem Tuning Register (R/W) */

/* Bank 3 */
#define FIR_CREG3_MTR  0x0 /* Master Control Register (R/W) */
#define FIR_CREG3_SMPR 0x1 /* Shared Memory Page Register (R/W) */
#define FIR_CREG3_TxDMA_SALR 0x2 /* TxDMA Start Address Low Register (R/W) */
#define FIR_CREG3_TxDMA_SAHR 0x3 /* TxDMA Start Address High Register (R/W) */
#define FIR_CREG3_RIDR 0x7 /* Revision ID Register */
