/*********************************************************************
 *                
 * Filename:      fir_skeleton.h
 * Version:       
 * Description:   
 * Status:        Experimental.
 * Author:        Haris Zukanovic <haris@stud.cs.uit.no>
 * Created at:    Tue Apr 14 12:41:42 1998
 * Modified at:   Tue Apr 14 15:40:33 1998
 * Modified by:   Haris Zukanovic <haris@stud.cs.uit.no>
 * 
 *     Copyright (c) 1998 Haris Zukanovic, All Rights Reserved.
 *      
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *  
 *     Neither Haris Zukanovic nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *     
 ********************************************************************/
#ifndef FIR_SKELETON_H
#define FIR_SKELETON_H

#include "irda.h"

#define SIR_MODE 0
#define MIR_MODE 1
#define FIR_MODE 2

struct fir_cb
{
	int fir_id;
	int fir_mode;
	char *fir_name;
	char *tty_name;
  
	int (*fir_xmit)(struct fir_cb *,struct sk_buff *);	/* send handler */
	int (*fir_change_speed)(struct fir_cb *,int);		/* set speed */
	int (*fir_is_media_busy)(struct fir_cb *);		/* media busy ? */
	int (*fir_is_receiving)(struct fir_cb *);		/* receiving ? */
	void (*fir_open) (struct fir_cb *, struct tty_struct *tty); /* we got an irattach */
	void (*fir_closed) (struct fir_cb *);			/* allow the module to be released */

};

#endif
