/*********************************************************************
 *                
 * Filename:      client_fsm.h
 * Version:       
 * Description:   LAN access
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Sun Aug 31 20:14:37 1997
 * Modified at:   Thu Sep 10 09:49:47 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1997 Dag Brattli <dagb@cs.uit.no>, All Rights Reserved.
 *     
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *
 *     Neither Dag Brattli nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *
 ********************************************************************/

#ifndef IRLAN_CLIENT_FSM_H
#define IRLAN_CLIENT_FSM_H

#include <linux/kernel.h>
#include <linux/skbuff.h>

#include "irlan_common.h"

typedef enum {
	IRLAN_CLIENT_IDLE,
	IRLAN_CLIENT_QUERY,
	IRLAN_CLIENT_CONN, 
	IRLAN_CLIENT_INFO,
	IRLAN_CLIENT_MEDIA,
	IRLAN_CLIENT_OPEN,
	IRLAN_CLIENT_WAIT,
	IRLAN_CLIENT_ARB, 
	IRLAN_CLIENT_DATA,
	IRLAN_CLIENT_CLOSE,
	IRLAN_CLIENT_SYNC
} IRLAN_CLIENT_STATE;

/* IrLAN Client Events */
typedef enum {
	IRLAN_DISCOVERY_INDICATION,
	IAS_PROVIDER_AVAIL,
	IAS_PROVIDER_NOT_AVAIL,
	LAP_DISCONNECT,
	LMP_DISCONNECT,
	CONNECT_COMPLETE,
/* 	CONNECT_INDICATION, */
	DATA_CONNECT_INDICATION,
	IRLAN_CLIENT_DATA_INDICATION,
	RETRY_CONNECT,
} IRLAN_CLIENT_EVENT;

struct irlan_client_info {
	__u8 dlsap_sel;
	__u32 daddr;
};

extern char *irlan_client_state[];

void irlan_client_do_event( struct irlan_client_cb *self, 
			    IRLAN_CLIENT_EVENT event, 
			    struct sk_buff *skb, 
			    struct irlan_client_info *info);
void irlan_client_next_state( struct irlan_client_cb *self, 
			      IRLAN_CLIENT_STATE state);

#endif
