/*********************************************************************
 *                
 * Filename:      server_fsm.h
 * Version:       
 * Description:   LAN access
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Sun Aug 31 20:14:37 1997
 * Modified at:   Tue Sep  8 09:32:20 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998 Dag Brattli <dagb@cs.uit.no>, All Rights Reserved.
 *     
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *
 *     Neither Dag Brattli nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *
 ********************************************************************/

#ifndef SERVER_FSM_H
#define SERVER_FSM_H

#include <linux/kernel.h>
#include <linux/skbuff.h>

#include "server.h"

typedef enum {
	IRLAN_SERVER_IDLE,
	IRLAN_SERVER_INFO,
	IRLAN_SERVER_OPEN,
	IRLAN_SERVER_DATA,
} IRLAN_SERVER_STATE;

/* IrLAN Server Events */
typedef enum {
	LAP_DISCONNECT,
	LMP_DISCONNECT,
	DATA_CONNECT_INDICATION,
	CONNECT_INDICATION,
	GET_INFO_CMD,
	GET_MEDIA_CMD,
	OPEN_DATA_CMD,
	FILTER_CONFIG_CMD,
} IRLAN_SERVER_EVENT;

struct irlan_server_info {
	__u8 dlsap_sel;
	__u32 daddr;
	struct tsap_cb *tsap;
};

extern char *irlan_server_state[];

void irlan_server_do_event( struct irlan_server_cb *self, 
			    IRLAN_SERVER_EVENT event, 
			    struct sk_buff *skb, 
			    struct irlan_server_info *info);
void irlan_server_next_state( struct irlan_server_cb *self, 
			      IRLAN_SERVER_STATE state);

#endif
