/*********************************************************************
 *                
 * Filename:      irlap_comp.h
 * Version:       
 * Description:   
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Fri Oct  9 09:21:12 1998
 * Modified at:   Fri Oct  9 22:19:34 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998 Dag Brattli, All Rights Reserved.
 *      
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *  
 *     Neither Dag Brattli nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *     
 ********************************************************************/

#  if LINUX_VERSION_CODE < 0x020100 
#define	 PACKETPTR 1
#include <linux/ppp_defs.h> 
#include <linux/ppp-comp.h>
#undef	 PACKETPTR
#  else
#include "ppp-comp-2.1.h"
#  endif

extern HASHBIN *irlap_compressors;

int irda_register_compressor( struct compressor *cp);
void irda_unregister_compressor( struct compressor *cp);

int irda_set_compression( struct irlap_cb *self, int proto);
void irlap_compressor_init( struct irlap_cb *self, int compress);
void irda_free_compression( struct irlap_cb *self);

struct sk_buff *irlap_compress_frame( struct irlap_cb *self, 
				      struct sk_buff *skb);
struct sk_buff *irlap_decompress_frame( struct irlap_cb *self, 
					struct sk_buff *skb);
