/*********************************************************************
 *                
 * Filename:      client.h<2>
 * Version:       0.1
 * Description:   
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Sat Feb 21 18:54:38 1998
 * Modified at:   Tue Sep 22 00:31:59 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998, Thomas Davis, <ratbert@radiks.net>
 *     Copyright (c) 1998, Dag Brattli, 
 *     All Rights Reserved
 *      
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *  
 *     I, Thomas Davis, provide no warranty for any of this software. This
 *     material is provided "AS-IS" and at no charge.
 *     
 ********************************************************************/

#ifndef IRLPT_CLIENT_H
#define IRLPT_CLIENT_H

/* Debug function */

/* #define CHECK_SKB(skb) check_skb((skb),  __LINE__,__FILE__) */

/* int  client_init( struct device *dev); */
int  client_init(void);
void client_cleanup(void);
void client_close(struct irlpt_cb *self);

void client_discovery_indication( __u32 daddr);

void client_data_request( struct irlpt_cb *self, struct sk_buff *skb);
void client_data_indication( void *instance, void *sap, struct sk_buff *skb);
void client_control_data_indication( void *instance, void *sap, 
				     struct sk_buff *skb);

void client_connect_request( struct irlpt_cb *self);
void client_connect( struct irlpt_cb *self, struct sk_buff *skb);
void client_connect_confirm( void *instance, void *sap, struct qos_info *qos, 
			     struct sk_buff *skb);
void client_disconnect_indication( void *instance, void *sap, LM_REASON reason,
				   struct sk_buff *userdata);
void client_flow_indication( int status);

void client_extract_params( struct sk_buff *skb);
void client_get_value_confirm(__u16 obj_id, __u8 type, int value_int, 
			     char *value_char, void *priv);

extern HASHBIN *irlpt;

#endif
