/*********************************************************************
 *                
 * Filename:      irlpt_event.h
 * Version:       0.1
 * Sources:       irlan_event.h
 * 
 *     Copyright (c) 1997 Dag Brattli <dagb@cs.uit.no>, All Rights Reserved.
 *     Copyright (c) 1998, Thomas Davis, <ratbert@radiks.net>, All Rights Reserved.
 *     
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *
 *     I, Thomas Davis, provide no warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *
 ********************************************************************/

#ifndef IRLPT_EVENT_H
#define IRLPT_EVENT_H

#include <linux/kernel.h>
#include <linux/skbuff.h>

typedef enum {
        LPT_IDLE,
	LPT_QUERY,
	LPT_READY,
	LPT_WAITI,
	LPT_WAITR,
	LPT_CONN,
} IRLPT_STATE;

/* IrLPT Events */
typedef enum {
        IRLPT_DISCOVERY_INDICATION,
	QUERY_REMOTE_IAS,
	IAS_PROVIDER_AVAIL,
	IAS_PROVIDER_NOT_AVAIL,
	LAP_DISCONNECT,
	LMP_CONNECT,
	LMP_DISCONNECT,
	LMP_CONNECT_INDICATION,
	LMP_DISCONNECT_INDICATION,
#if 0
	TTP_CONNECT_INDICATION,
	TTP_DISCONNECT_INDICATION,
#endif
	LPT_CONNECT_REQUEST,
	LPT_DISCONNECT_REQUEST,
	CLIENT_DATA_INDICATION,
} IRLPT_EVENT;

struct irlpt_frame {
	__u8 dlsap;
	__u32 daddr;
};


void irlpt_do_event( struct irlpt_cb *self,  IRLPT_EVENT event, struct sk_buff *skb, 
					 struct irlpt_frame *frame);
void irlpt_next_state( struct irlpt_cb *self, IRLPT_STATE state);

#endif
