/*********************************************************************
 *                
 * Filename:      server.h
 * Version:       0.1
 * Description:   
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Sat Feb 21 18:54:38 1998
 * Modified at:   Tue Sep 22 11:41:42 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998, Thomas Davis, <ratbert@radiks.net>
 *     Copyright (c) 1998, Dag Brattli, 
 *     All Rights Reserved
 *      
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *  
 *     I, Thomas Davis, provide no warranty for any of this software. This
 *     material is provided "AS-IS" and at no charge.
 *     
 ********************************************************************/

#ifndef IRLPT_SERVER_H
#define IRLPT_SERVER_H

#include "qos.h"
#include "irmod.h"

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/skbuff.h>
#include <linux/netdevice.h>
#include <linux/miscdevice.h>

/* int  server_init( struct device *dev); */
int  server_init(void);
void server_cleanup(void);
struct server_cb *irlpt_open(void);
void server_close(struct irlpt_cb *self);

void server_data_request( struct irlpt_cb *self, struct sk_buff *skb);
void server_data_indication( void *instance, void *sap, struct sk_buff *skb);
void server_control_data_indication( void *instance, void *sap, 
				     struct sk_buff *skb);

void server_connect_request( struct irlpt_cb *self);
void server_connect(struct irlpt_cb *self, struct sk_buff *skb);
void server_connect_confirm( void *instance, void *sap, struct qos_info *qos, 
			    struct sk_buff *skb);
void server_disconnect_indication( void *instance, void *sap, LM_REASON reason,
				   struct sk_buff *skb);
void server_flow_indication( int status);

void server_extract_params( struct sk_buff *skb);
void server_get_value_confirm(__u16 obj_id, __u8 type, int value_int, 
			     char *value_char, void *priv);
void register_server(void);

extern struct irlpt_cb *irlptd;

#endif
