/*********************************************************************
 *                
 * Filename:      irobex.c<2>
 * Version:       0.2
 * Description:   IrOBEX Gtk+ User Interface
 * Status:        Experimental.
 * Author:        Dag Brattli <dagb@cs.uit.no>
 * Created at:    Mon Aug 24 11:11:54 1998
 * Modified at:   Fri Oct 16 22:24:03 1998
 * Modified by:   Dag Brattli <dagb@cs.uit.no>
 * 
 *     Copyright (c) 1998 Dag Brattli, All Rights Reserved.
 *      
 *     This program is free software; you can redistribute it and/or 
 *     modify it under the terms of the GNU General Public License as 
 *     published by the Free Software Foundation; either version 2 of 
 *     the License, or (at your option) any later version.
 *  
 *     Neither Dag Brattli nor University of Troms admit liability nor
 *     provide warranty for any of this software. This material is 
 *     provided "AS-IS" and at no charge.
 *     
 ********************************************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#include "../irobex_lib.h"

#define MODE_SEND    1
#define MODE_RECEIVE 2

void save();

IROBEX_HANDLE *handle;
IROBEX_OBJECT *my_object;

int i;

/*
 * Function object_indication_callback (object)
 *
 *    Called by the IrOBEX layer when it have successfully received an
 *    object
 *
 */
void object_indication_callback( IROBEX_OBJECT *object) 
{
	DEBUG( 0, "object_indication_callback()\n");

	my_object = object;

  printf("***Incomming Object Name: %s ***\nDescription : %s\n", object->name,
      object->description);
  
  /* 1 - Dump the data into a file */
  save();

  i = 1;
}

/*
 * Function dialog_save_callback (button, user_data)
 *
 *    Save file to disk
 *
 */
void save()
{
	int fd;
	int actual;

	printf("save()\n");

	fd = open( my_object->name, O_RDWR | O_CREAT);
	if ( fd < 0) {
		perror( my_object->name);
		return;
	}
	
	actual = write( fd, my_object->body, my_object->length);
	
	/* Deallocate body */
	free( my_object->body);
	free( my_object);
	
	my_object = NULL;
}

/*
 * Function create_dialog (filename, from, ok_callback)
 *
 *    Create the notification dialog
 *
 */
  /*
GtkWidget *create_dialog( char *filename, char *from)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *hbox2;
  GdkPixmap *glade_pixmap;
  GdkBitmap *glade_mask;
  GtkWidget *pixmap1;
  GtkWidget *vbox1;
  GtkWidget *label1;
  GtkWidget *hbox4;
  GtkWidget *label4;
  GtkWidget *label6;
  GtkWidget *hbox5;
  GtkWidget *label5;
  GtkWidget *label7;
  GtkWidget *dialog_action_area1;
  GtkWidget *hbox1;
  GtkWidget *button1;
  GtkWidget *button2;
  GtkWidget *button3;

  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), "IrOBEX object received");
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  hbox2 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "hbox2", hbox2);
  gtk_widget_show (hbox2);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), hbox2, TRUE, TRUE, 0);

  gtk_widget_realize (dialog1);
  glade_pixmap = gdk_pixmap_create_from_xpm (dialog1->window, &glade_mask,
                                             &dialog1->style->bg[GTK_STATE_NORMAL],
                                             "/usr/share/pixmaps/panel-menu-main.xpm");
  pixmap1 = gtk_pixmap_new (glade_pixmap, glade_mask);
  gdk_pixmap_unref (glade_pixmap);
  gdk_bitmap_unref (glade_mask);
  gtk_object_set_data (GTK_OBJECT (dialog1), "pixmap1", pixmap1);
  gtk_widget_show (pixmap1);
  gtk_box_pack_start (GTK_BOX (hbox2), pixmap1, TRUE, TRUE, 0);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "vbox1", vbox1);
  gtk_widget_show (vbox1);
  gtk_box_pack_start (GTK_BOX (hbox2), vbox1, TRUE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (vbox1), 10);

  label1 = gtk_label_new ("You have just been beamed: ");
  gtk_object_set_data (GTK_OBJECT (dialog1), "label1", label1);
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (vbox1), label1, TRUE, TRUE, 0);

  hbox4 = gtk_hbox_new (FALSE, 10);
  gtk_object_set_data (GTK_OBJECT (dialog1), "hbox4", hbox4);
  gtk_widget_show (hbox4);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox4, TRUE, TRUE, 0);

  label4 = gtk_label_new ("File");
  gtk_object_set_data (GTK_OBJECT (dialog1), "label4", label4);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox4), label4, FALSE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);

  label6 = gtk_label_new ( filename);
  gtk_object_set_data (GTK_OBJECT (dialog1), "label6", label6);
  gtk_widget_show (label6);
  gtk_box_pack_start (GTK_BOX (hbox4), label6, FALSE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);

  hbox5 = gtk_hbox_new (FALSE, 10);
  gtk_object_set_data (GTK_OBJECT (dialog1), "hbox5", hbox5);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox1), hbox5, TRUE, TRUE, 0);

  label5 = gtk_label_new ("From");
  gtk_object_set_data (GTK_OBJECT (dialog1), "label5", label5);
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox5), label5, FALSE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);

  label7 = gtk_label_new (from);
  gtk_object_set_data (GTK_OBJECT (dialog1), "label7", label7);
  gtk_widget_show (label7);
  gtk_box_pack_start (GTK_BOX (hbox5), label7, FALSE, TRUE, 0);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", 
		       dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_object_set_data (GTK_OBJECT (dialog1), "hbox1", hbox1);
  gtk_widget_show (hbox1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), hbox1, TRUE, TRUE, 0);

  button1 = gtk_button_new_with_label ("Save");
  gtk_object_set_data (GTK_OBJECT (dialog1), "button1", button1);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (hbox1), button1, TRUE, TRUE, 0);
  gtk_signal_connect_object (GTK_OBJECT (button1), "clicked",
                             GTK_SIGNAL_FUNC (dialog_save_callback),
                             GTK_OBJECT (dialog1));

  button2 = gtk_button_new_with_label ("Save As ...");
  gtk_object_set_data (GTK_OBJECT (dialog1), "button2", button2);
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (hbox1), button2, TRUE, TRUE, 0);
  gtk_signal_connect( GTK_OBJECT (button2),
		      "clicked", (GtkSignalFunc) dialog_saveas_callback, NULL);

  button3 = gtk_button_new_with_label ("Cancel");
  gtk_object_set_data (GTK_OBJECT (dialog1), "button3", button3);
  gtk_widget_show (button3);
  gtk_box_pack_start (GTK_BOX (hbox1), button3, TRUE, TRUE, 0);
  gtk_signal_connect_object (GTK_OBJECT(button3),
			     "clicked", 
			     (GtkSignalFunc) gtk_widget_destroy,
			     GTK_OBJECT (dialog1));

  return dialog1;
}
  */

/*
 * Function main (argc, )
 *
 *    
 *
 */
int main (int argc, char *argv[])
{
  char chr = 0;

  /*
   *  Be sure that the IrOBEX module is loaded
  system( "load_misc irobex\n");
   */

  /*
   *  Initialize IrOBEX
   */
  printf("Calling irobex_init\n");
  handle = irobex_init( &object_indication_callback);

  /* Now when the button is clicked, we call the "callback" function
   * with a pointer to "button 1" as it's argument 
  gtk_signal_connect( GTK_OBJECT (button), "clicked",
 GTK_SIGNAL_FUNC (button_send_callback), 
 (gpointer) "button send");
    */

  /*
   *  Call the main loop!
   */
  /*
  gtk_main ();
  */
  
  while(chr != 'q') {
    chr = getchar();
  }
  return 0;

}
